/******************************************
MODULO: back_write.c
SCOPO:  Scrivere un file al contrario
				dall'ultima alla prima riga su stdout
******************************************/
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include "mylib.h"

void backward(char *from); /* dichiarazione della funzione di inversione */

int main (int argc, char **argv)
{

	if (argc != 2) {
		fprintf(stderr,"Usage: back_write <sourcefile>.\n");
		exit(1);
	}
	
	 /* chiamata alla funzione di inversione */
	...
		
}


/* definizione della funzione di inversione*/
void backward(char *from) {
	char s[101]; /* vettore che contiene una riga del file*/
	char c; /* buffer per leggere un solo carattere alla volta*/
	int i; /* indice per il vettore di caratteri s */
	int fd_from; /* file descriptor */
	int nread; /* numero di caratteri letti */
	long where; /* posizione all'interno del file */
	
	/* 
		Apertura del file 
	*/
	....
		
	/*
		Mi posiziono davanti all'ultimo carattere del file
	*/	
	...
	/* 
		Chiudo il vettore di caratteri inserendo il tappo (cio '\0')
		nell'ultima posizione del vettore
	*/	
	....
	
	/*
		Leggo un carattere alla volta a partire dall'ultimo.
		Ogni volta che leggo il carattere "\n" significa che ho
		letto tutta una riga e quindi posso scriverla sullo stdout.
	*/

	/*leggo il carattere*/
	while (...) {
		
		/* se ho letto "\n" allora posso scrivere la riga sullo stdout */
		/* e riporto l'indice del vettore s all'ultimo valore*/		
		...
		
		/* Se l'indice i diventa 0 ho finito lo spazio sul vettore s, 
		quindi lo comunico all'utente ed eseguo una exit*/
	 	...
		
		/*
			Memorizzo in s il carattere letto dal file dopo aver aggiornato il
			valore per l'indice i.
			Notare che i caratteri vengono inseriti nel vettore s a partire dalla
			posizione finale per preservare l'ordine dei caratteri nella stampa. 
			Infatti le righe del file devono essere invertite
			(l'ultima sar la prima, etc...) ma i caratteri all'interno di una 
			riga devono rimanere nell'ordine iniziale.
			N.B: --i significa che prima decremento il valore di i e poi lo uso
			     i-- significa che prima uso il valore di i e poi lo decremento
		*/
		...
	
		/*
			Se lseek ritorna 0 significa che sono arrivato all'inizio del file
			e quindi ho finito di leggere ed esco dal while
		*/
		....
			
		/*
			Dopo aver letto un carattere devo risalire nel file di 2 posizioni:
			quella che ho appena letto e quella che voglio leggere ora
		*/
	
	}
	

	if (nread == -1) 
		syserr("backward", "read");
	
	/*
		Scrivo l'ultima riga (la prima del file originale)
	*/
	....
	
	/*
		Chiundo il file
	*/
	
}
